=== modified file 'consumption_calculation/history_consumption.py'
--- consumption_calculation/history_consumption.py	2012-03-27 14:38:50 +0000
+++ consumption_calculation/history_consumption.py	2012-04-02 14:58:09 +0000
@@ -40,6 +40,10 @@
         'location_id': fields.many2one('stock.location', string='Location', domain="[('usage', '=', 'internal')]"),
         'sublist_id': fields.many2one('product.list', string='List/Sublist'),
         'nomen_id': fields.many2one('product.nomenclature', string='Products\' nomenclature level'),
+        'nomen_manda_0': fields.many2one('product.nomenclature', 'Main Type'),
+        'nomen_manda_1': fields.many2one('product.nomenclature', 'Group'),
+        'nomen_manda_2': fields.many2one('product.nomenclature', 'Family'),
+        'nomen_manda_3': fields.many2one('product.nomenclature', 'Root'),
     }
 
     _defaults = {
@@ -53,7 +57,7 @@
         return {'type': 'ir.actions.act_window',
                 'res_model': 'product.history.consumption',
                 'res_id': new_id,
-                'context': {'active_id': new_id, 'active_ids': [new_id]},
+                'context': {'active_id': new_id, 'active_ids': [new_id], 'withnum': 1},
                 'view_type': 'form',
                 'view_mode': 'form',
                 'target': 'dummy'}
@@ -127,48 +131,34 @@
         nb_months = len(months)
         total_consumption = {}
 
-        if obj.nomen_id:
-            nomen_id = obj.nomen_id.id
-            nomen = self.pool.get('product.nomenclature').browse(cr, uid, nomen_id, context=context)
-            if nomen.type == 'mandatory':
-                product_ids.extend(self.pool.get('product.product').search(cr, uid, [('nomen_manda_0', '=', nomen_id)], context=context))
-                product_ids.extend(self.pool.get('product.product').search(cr, uid, [('nomen_manda_1', '=', nomen_id)], context=context))
-                product_ids.extend(self.pool.get('product.product').search(cr, uid, [('nomen_manda_2', '=', nomen_id)], context=context))
-                product_ids.extend(self.pool.get('product.product').search(cr, uid, [('nomen_manda_3', '=', nomen_id)], context=context))
-                # Prefill the search view
-                tmp_nomen = [nomen]
-                while nomen.parent_id:
-                    tmp_nomen.append(nomen.parent_id.id)
-                    nomen = nomen.parent_id
-
-                tmp_nomen.reverse()
-
-                i = 0
-                while i < len(tmp_nomen):
-                    context.update({'search_default_nomen_manda_%s' %i: obj.sublist_id.id})
-                    i += 1
-            else:
-                product_ids.extend(self.pool.get('product.product').search(cr, uid, [('nomen_sub_0', '=', nomen_id)], context=context))
-                product_ids.extend(self.pool.get('product.product').search(cr, uid, [('nomen_sub_1', '=', nomen_id)], context=context))
-                product_ids.extend(self.pool.get('product.product').search(cr, uid, [('nomen_sub_2', '=', nomen_id)], context=context))
-                product_ids.extend(self.pool.get('product.product').search(cr, uid, [('nomen_sub_3', '=', nomen_id)], context=context))
-                product_ids.extend(self.pool.get('product.product').search(cr, uid, [('nomen_sub_4', '=', nomen_id)], context=context))
-                product_ids.extend(self.pool.get('product.product').search(cr, uid, [('nomen_sub_5', '=', nomen_id)], context=context))
-                # Prefill the search view
-                tmp_nomen = [nomen]
-                while nomen.parent_id:
-                    tmp_nomen.append(nomen.parent_id.id)
-                    nomen = nomen.parent_id
-
-                tmp_nomen.reverse()
-
-                i = 0
-                while i < len(tmp_nomen):
-                    if i > 3:
-                        context.update({'search_default_nomen_sub_%s' % i-3: obj.sublist_id.id})
-                    else:
-                        context.update({'search_default_nomen_manda_%s' % i: obj.sublist_id.id})
-                    i += 1
+        if obj.nomen_manda_0:
+            for report in self.browse(cr, uid, ids, context=context):
+                product_ids = []
+                products = []
+    
+                nom = False
+                # Get all products for the defined nomenclature
+                if report.nomen_manda_3:
+                    nom = report.nomen_manda_3.id
+                    field = 'nomen_manda_3'
+                elif report.nomen_manda_2:
+                    nom = report.nomen_manda_2.id
+                    field = 'nomen_manda_2'
+                elif report.nomen_manda_1:
+                    nom = report.nomen_manda_1.id
+                    field = 'nomen_manda_1'
+                elif report.nomen_manda_0:
+                    nom = report.nomen_manda_0.id
+                    field = 'nomen_manda_0'
+                if nom:
+                    product_ids.extend(self.pool.get('product.product').search(cr, uid, [(field, '=', nom)], context=context))
+                    
+            for product in self.pool.get('product.product').browse(cr, uid, product_ids, context=context):
+                # Check if the product is not already on the report
+                if product.id not in products:
+                    batch_mandatory = product.batch_management or product.perishable
+                    date_mandatory = not product.batch_management and product.perishable
+                    self.pool.get('product.product').write(cr, uid, ids, {'name': product.id,})
 
         if obj.sublist_id:
             context.update({'search_default_list_ids': obj.sublist_id.id})
@@ -177,7 +167,7 @@
 
         domain = [('id', 'in', product_ids)]
 
-        if not obj.nomen_id and not obj.sublist_id:
+        if not obj.nomen_manda_0 and not obj.sublist_id:
             domain = []
 
         new_context = context.copy()
@@ -196,9 +186,32 @@
                 'context': new_context,
                 'target': 'dummy'}
 
+##############################################################################################################################
+# The code below aims to enable filtering products regarding their nomenclature.
+# NB: the difference with the other same kind of product filters (with nomenclature and sublist) is that here we are dealing with osv_memory
+##############################################################################################################################
+    def onChangeSearchNomenclature(self, cr, uid, id, position, type, nomen_manda_0, nomen_manda_1, nomen_manda_2, nomen_manda_3, num=True, context=None):
+        res = self.pool.get('product.product').onChangeSearchNomenclature(cr, uid, 0, position, type, nomen_manda_0, nomen_manda_1, nomen_manda_2, nomen_manda_3, False, context={'withnum': 1})
+        return res
+
+    def get_nomen(self, cr, uid, id, field):
+        return self.pool.get('product.nomenclature').get_nomen(cr, uid, self, id, field, context={'withnum': 1})
+
+    def write(self, cr, uid, ids, vals, context=None):
+        if vals.get('sublist_id',False):
+            vals.update({'nomen_manda_0':False,'nomen_manda_1':False,'nomen_manda_2':False,'nomen_manda_3':False})
+        if vals.get('nomen_manda_0',False):
+            vals.update({'sublist_id':False})
+        if vals.get('nomen_manda_1',False):
+            vals.update({'sublist_id':False})
+        ret = super(product_history_consumption, self).write(cr, uid, ids, vals, context=context)
+        return ret
+##############################################################################
+# END of the definition of the product filters and nomenclatures
+##############################################################################
+
 product_history_consumption()
 
-
 class product_history_consumption_month(osv.osv_memory):
     _name = 'product.history.consumption.month'
     _order = 'name, date_from, date_to'

=== modified file 'consumption_calculation/history_consumption_view.xml'
--- consumption_calculation/history_consumption_view.xml	2011-11-16 16:51:50 +0000
+++ consumption_calculation/history_consumption_view.xml	2012-03-16 15:09:27 +0000
@@ -24,12 +24,35 @@
 		    	<field name="consumption_type" />
 		    	<field name="location_id" attrs="{'invisible': [('consumption_type', '!=', 'rac')], 'required': [('consumption_type', '=', 'rac')]}" />
 			<separator colspan="2" string="Product parameters" />
-			<field name="nomen_id" />
-			<field name="sublist_id" />
+            <field name="sublist_id" attrs="{'readonly': [('nomen_manda_0', '!=', False)]}" />
+            <group colspan="2" col="4" attrs="{'readonly': [('sublist_id', '!=', False)]}">
+                <field name="nomen_manda_0"
+                    domain="[('level', '=', '0'), ('type', '=', 'mandatory')]"
+                    widget="selection"
+                    on_change="onChangeSearchNomenclature(0, 'mandatory', nomen_manda_0, nomen_manda_1, nomen_manda_2, nomen_manda_3, False)"
+                />
+                <field name="nomen_manda_1"
+                    domain="[('id','=', 0)]"
+                    widget="selection"
+                    get_selection="get_nomen"
+                    on_change="onChangeSearchNomenclature(1, 'mandatory', nomen_manda_0, nomen_manda_1, nomen_manda_2, nomen_manda_3, False)"
+                />
+                <field name="nomen_manda_2"
+                    domain="[('id','=', 0)]"
+                    widget="selection"
+                    get_selection="get_nomen"
+                    on_change="onChangeSearchNomenclature(2, 'mandatory', nomen_manda_0, nomen_manda_1, nomen_manda_2, nomen_manda_3, False)"
+                />
+                <field name="nomen_manda_3"
+                    domain="[('id','=', 0)]"
+                    widget="selection"
+                    get_selection="get_nomen"
+                    on_change="onChangeSearchNomenclature(3, 'mandatory', nomen_manda_0, nomen_manda_1, nomen_manda_2, nomen_manda_3, False)"
+                />
+            </group>
 			<separator colspan="2" string="Actions" />
 			<button name="create_lines" type="object" string="View historical data" icon="gtk-execute" colspan="2" />
 		    </group>
-
 		</form>
 	    </field>
 	</record>
@@ -49,7 +72,7 @@
             <field name="key2">tree_but_open</field>
             <field name="model">ir.ui.menu</field>
             <field name="name">Historical consumptions</field>
-	    <field name="res_id" ref="menu_product_history_consumption" />
+	        <field name="res_id" ref="menu_product_history_consumption" />
             <field eval="'ir.actions.server,%d'%action_open_history_consumption_view" name="value"/>
             <field eval="True" name="object"/>
         </record>

=== modified file 'procurement_cycle/procurement_view.xml'
--- procurement_cycle/procurement_view.xml	2012-03-28 07:15:43 +0000
+++ procurement_cycle/procurement_view.xml	2012-04-02 14:58:09 +0000
@@ -80,7 +80,7 @@
                     <button colspan="4" icon="gtk-go-down" string="Fill lines" type="object" name="fill_lines" />
 
                     <group colspan="4" col="4" >
-                        <separator colspan="4" string="Products" />
+                        <separator colspan="4" string="Products that will be included in the current policy" />
                         <!-- <field name="product_ids" nolabel="1" colspan="4" domain="[('fnct_categ_id', '=', category_id)]"/>
                          -->
                         <field name="product_ids" nolabel="1" colspan="4" 

=== modified file 'product_nomenclature/product_nomenclature.py'
--- product_nomenclature/product_nomenclature.py	2012-03-29 15:42:56 +0000
+++ product_nomenclature/product_nomenclature.py	2012-04-02 14:58:09 +0000
@@ -283,6 +283,10 @@
         parent = {'nomen_manda_1': 'nomen_manda_0', 'nomen_manda_2': 'nomen_manda_1', 'nomen_manda_3': 'nomen_manda_2'}
         level = {'nomen_manda_1': 1, 'nomen_manda_2': 2, 'nomen_manda_3': 3}
         p_id = obj.read(cr, uid, id, [parent[field]])[parent[field]]
+        # when dealing with osv_memory, the read method for many2one returns the id and not the tuple (id, name) as for osv.osv
+        if p_id and isinstance(p_id, int):
+            name = self.name_get(cr, uid, [p_id], context=context)[0]
+            p_id = name
         dom = [('level', '=',  level.get(field)), ('type', '=', 'mandatory'), ('parent_id', '=', p_id and p_id[0] or 0)]
         return self._name_search(cr, uid, '', dom, limit=None, name_get_uid=1, context=context)
     

=== modified file 'threshold_value/threshold_value_view.xml'
--- threshold_value/threshold_value_view.xml	2012-03-19 16:34:41 +0000
+++ threshold_value/threshold_value_view.xml	2012-04-02 14:58:09 +0000
@@ -106,6 +106,7 @@
         	<field name="arch" type="xml">
         		<tree string="Threshold value">
         			<field name="name" />
+        			<field name="product_id" invisible="1" />
         			<field name="location_id" />
                     <field name="sublist_id" invisible="1" />
                     <field name="nomen_manda_0" invisible="1" />

